<template>
  <authenticated-vue>
    <div class="w-100 bg-white shadow-lg p-5" id="card">
      <form @submit.prevent="submit">
        <header class="text-gray-600 py-3 pb-5 flex justify-between">
          <h3 class="text-xl">
            {{
              project && project.name
                ? "อัพเดทข้อมูลโครงการ"
                : "เพิ่มข้อมูลโครงการ"
            }}
          </h3>
          <button
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-blue-400
              to-green-300
              rounded-md
              text-white
              shadow-md
            "
          >
            {{ project && project.name ? "อัพเดท" : "เพิ่ม" }}
          </button>
        </header>
        <div id="content">
          <div class="grid grid-cols-1 lg:grid-cols-3 md:grid-cols-2 gap-5">
            <div class="grid">
              <div class="flex justify-between">
                <label for="name"
                  >ปีงบประมาณ <small class="text-red-500">*</small>
                </label>
              </div>
              <el-select
                v-model="formProject.budget_year_id"
                filterable
                placeholder="ปีงบประมาณ"
                @change="getStargis"
              >
                <el-option
                  v-for="item in budget_years"
                  :key="item.id"
                  :label="item.year"
                  :value="item.id"
                >
                </el-option>
              </el-select>
              <small class="text-red-500 font-bold"
                >{{ errors?.budget_year_id }}
              </small>
            </div>

            <div class="grid">
              <div class="flex justify-between">
                <label for="name"
                  >ยุทธศาสตร์ <small class="text-red-500">*</small>
                </label>
              </div>
              <el-select
                v-model="formProject.stargic_id"
                filterable
                placeholder="ยุทธศาสตร์"
                :disabled="!formProject.budget_year_id"
                @change="getMains"
              >
                <el-option
                  v-for="item in stargics"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                >
                  <div class="d-flex justify-between">
                    <span>ยุทธศาสตร์ที่ : {{ item.number }} &nbsp;</span>
                    <span>{{ item.name }} &nbsp;</span>
                    <span>{{ item.lastname }} </span>
                  </div>
                </el-option>
              </el-select>
              <small class="text-red-500 font-bold">{{
                errors?.stargic_id
              }}</small>
            </div>

            <div class="grid col-span-2">
              <div class="flex justify-between">
                <label for="name"
                  >โครงการหลัก
                  <small class="text-gray-500"> ( ถ้ามี ) </small>
                </label>
                <small
                  class="
                    text-blue-400
                    cursor-pointer
                    hover:text-blue-700
                    hover:underline
                    font-bold
                  "
                  v-if="
                    !(
                      (formProject.budget_year_id && !formProject.stargic_id) ||
                      (!formProject.budget_year_id && !formProject.stargic_id)
                    )
                  "
                  @click="openCreateMainProject = true"
                >
                  เพิ่มข้อมูล
                </small>
              </div>
              <el-select
                v-model="formProject.main_project_id"
                filterable
                placeholder="โครงการหลัก"
                @change="getSides"
                :disabled="
                  (formProject.budget_year_id && !formProject.stargic_id) ||
                  (!formProject.budget_year_id && !formProject.stargic_id)
                "
              >
                <el-option
                  v-for="item in mains"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                >
                  <div class="d-flex justify-between">
                    <span>{{ item.name }} </span>
                  </div>
                </el-option>
              </el-select>
              <small class="text-red-500 font-bold">{{
                errors?.main_project_id
              }}</small>
            </div>

            <div class="grid">
              <div class="flex justify-between">
                <label for="name"
                  >ด้าน <small class="text-gray-500">( ถ้ามี )</small>
                </label>
                <small
                  class="
                    text-blue-400
                    cursor-pointer
                    hover:text-blue-700
                    hover:underline
                    font-bold
                  "
                  v-if="
                    !(
                      (formProject.budget_year_id &&
                        formProject.stargic_id &&
                        !formProject.main_project_id) ||
                      (formProject.budget_year_id &&
                        !formProject.stargic_id &&
                        !formProject.main_project_id) ||
                      (!formProject.budget_year_id &&
                        !formProject.stargic_id &&
                        !formProject.main_project_id)
                    )
                  "
                  @click="openCreateSide = true"
                >
                  เพิ่มข้อมูล
                </small>
              </div>
              <el-select
                v-model="formProject.side_id"
                filterable
                placeholder="ด้าน"
                :disabled="
                  (formProject.budget_year_id &&
                    formProject.stargic_id &&
                    !formProject.main_project_id) ||
                  (formProject.budget_year_id &&
                    !formProject.stargic_id &&
                    !formProject.main_project_id) ||
                  (!formProject.budget_year_id &&
                    !formProject.stargic_id &&
                    !formProject.main_project_id)
                "
              >
                <el-option
                  v-for="item in sides"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                >
                  <div class="d-flex justify-between">
                    <span>{{ item.name }} </span>
                  </div>
                </el-option>
              </el-select>
              <small class="text-red-500 font-bold">{{
                errors?.main_project_id
              }}</small>
            </div>

            <div class="grid col-span-full">
              <label for="name"
                >ชื่อโครงการ <small class="text-red-500">*</small>
              </label>
              <input
                type="text"
                class="
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300
                "
                v-model="formProject.name"
                placeholder="ชื่อโครงการ"
              />
              <small class="text-red-500 font-bold">{{ errors?.name }}</small>
            </div>

            <div class="grid col-span-full md:grid-cols-2 gap-5">
              <div class="grid">
                <div class="flex justify-between">
                  <label for="name"
                    >ผู้รับผิดชอบโครงการ
                    <small class="text-red-500">*</small></label
                  >
                  <small
                    class="
                      text-blue-400
                      cursor-pointer
                      hover:text-blue-700
                      hover:underline
                      font-bold
                    "
                    @click="openCreateOwner = true"
                    >เพิ่มข้อมูล</small
                  >
                </div>
                <el-select
                  v-model="formProject.owners"
                  multiple
                  filterable
                  placeholder="ผู้รับผิดชอบโครงการ"
                >
                  <el-option
                    v-for="item in owners"
                    :key="item.id"
                    :value="item.id"
                    :label="item.firstname"
                  >
                    <div class="d-flex justify-between">
                      <span>{{ item.title }}</span>
                      <span>{{ item.firstname }} &nbsp;</span>
                      <span>{{ item.lastname }} </span>
                    </div>
                  </el-option>
                </el-select>
                <small class="text-red-500 font-bold">{{
                  errors?.owners
                }}</small>
              </div>
              <div class="grid">
                <div class="flex justify-between">
                  <label for="name"
                    >พื้นที่ดำเนินงาน <small class="text-red-500">*</small>
                  </label>
                  <small
                    class="
                      text-blue-400
                      cursor-pointer
                      hover:text-blue-700
                      hover:underline
                      font-bold
                    "
                    @click="openCreateArea = true"
                    >เพิ่มข้อมูล</small
                  >
                </div>
                <el-select
                  v-model="formProject.areas"
                  filterable
                  placeholder="พื้นที่ดำเนินงาน"
                  multiple
                >
                  <el-option
                    v-for="item in areas"
                    :key="item.id"
                    :label="item.address"
                    :value="item.id"
                  >
                  </el-option>
                </el-select>
                <small class="text-red-500 font-bold">{{
                  errors?.areas
                }}</small>
              </div>
            </div>

            <div class="grid col-span-full">
              <label for="name"
                >ระยะเวลาดำเนินการ <small class="text-red-500">*</small>
              </label>
              <div class="grid sm:grid-cols-2 md:grid-cols-3 gap-5">
                <el-date-picker
                  v-model="formProject.project_start"
                  type="date"
                  placeholder="วันที่เริ่มต้น"
                >
                </el-date-picker>
                <el-date-picker
                  v-model="formProject.project_end"
                  type="date"
                  placeholder="วันที่สิ้นสุด"
                >
                </el-date-picker>
                <small class="text-red-500 font-bold">{{
                  errors?.project_start
                }}</small>
                <small class="text-red-500 font-bold">{{
                  errors?.project_end
                }}</small>
              </div>
            </div>

            <div class="col-span-full">
              <div class="flex justify-between">
                <label for="name"
                  >วัตถุประสงค์โครงการ <small class="text-red-500">*</small>
                </label>
                <small
                  class="
                    text-blue-400
                    cursor-pointer
                    hover:text-blue-700
                    hover:underline
                    font-bold
                  "
                  @click="AddObjectiveCount"
                  >เพิ่ม</small
                >
              </div>
              <div
                v-for="(objective, i) in formProject.objectives.length"
                :key="i"
                class="mb-1"
              >
                <el-input
                  :validate-event="true"
                  placeholder="วัตถุประสงค์"
                  v-model="formProject.objectives[i].detail"
                >
                  <template #prefix>
                    <span class="ml-2">{{ 1 + i }}.</span>
                  </template>
                </el-input>
                <small
                  class="text-red-500 cursor-pointer hover:underline font-bold"
                  v-if="i >= 1"
                  @click="RemoveObjectiveCount"
                  >ลบ
                </small>
              </div>
            </div>

            <div class="col-span-full">
              <div class="flex justify-between">
                <label for="name"
                  >งบประมาณ <small class="text-red-500">*</small>
                </label>
                <small
                  class="
                    text-blue-400
                    cursor-pointer
                    hover:text-blue-700
                    hover:underline
                    font-bold
                  "
                  @click="AddBudgetCount"
                  >เพิ่ม</small
                >
              </div>
              <div
                class="grid grid-cols-4 gap-5 mb-2"
                v-for="(data, i) in formProject.budgets.length"
                :key="i"
              >
                <input
                  type="text"
                  class="
                    col-span-3
                    px-3
                    py-2
                    rounded
                    border border-gray-200
                    placeholder-gray-300
                  "
                  placeholder="รายละเอียดงบประมาณ"
                  v-model="formProject.budgets[i].detail"
                />
                <input
                  type="text"
                  class="
                    px-3
                    py-2
                    rounded
                    border border-gray-200
                    placeholder-gray-300
                  "
                  placeholder="งบประมาณ"
                  v-model="formProject.budgets[i].number"
                />
                <small
                  class="text-red-500 font-bold cursor-pointer hover:underline"
                  @click="RemoveBudgetCount"
                  v-if="i >= 1"
                  >ลบ
                </small>
              </div>
            </div>

            <div class="col-span-full grid">
              <span>แนบลิงค์</span>
              <input
                type="text"
                class="
                  px-3
                  py-2
                  rounded
                  border border-gray-200
                  placeholder-gray-300
                "
                placeholder="ลิงค์รายละเอียดโครงการ"
                v-model="formProject.link"
              />
            </div>
            <div class="grid">
              <div class="flex justify-between">
                <label for="name"
                  >เอกสารข้อมูล <small class="text-red-500">*</small>
                </label>
              </div>
              <el-upload
                class="upload-demo"
                drag
                :action="route('upload')"
                :on-success="handleUploadSuccess"
                :before-upload="beforeUpload"
                :on-remove="handleRemoveSuccess"
                :file-list="formProject.projectFiles"
                multiple
              >
                <i class="el-icon-upload"></i>
                <div class="el-upload__text">
                  Drop file here or <em>click to upload</em>
                </div>
                <template #tip>
                  <div class="el-upload__tip">
                    pdf/doc files with a size less than 2Mb
                  </div>
                </template>
              </el-upload>
              <small class="text-red-500 font-bold"
                >{{ errors?.projectFiles }}
              </small>
            </div>
          </div>
        </div>
        <footer class="text-gray-600 py-3 pt-5 flex justify-between">
          <button
            class="
              transition
              duration-200
              ease-in-out
              transform
              hover:-translate-y-1
              px-3
              py-1
              bg-gradient-to-r
              from-blue-400
              to-green-300
              rounded-md
              text-white
              shadow-md
            "
          >
            {{ project && project.name ? "อัพเดท" : "เพิ่ม" }}
          </button>
        </footer>
      </form>
      <div>
        <create-main-project
          :open="openCreateMainProject"
          :year="year"
          :stargic="stargic"
          :errors="errors"
          @close="openCreateMainProject = false"
        />
        <create-side
          :open="openCreateSide"
          :year="year"
          :stargic="stargic"
          :main="main"
          :errors="errors"
          @close="openCreateSide = false"
        />
        <create-owner
          :open="openCreateOwner"
          @close="openCreateOwner = false"
          :errors="errors"
        />
        <create-area :open="openCreateArea" @close="openCreateArea = false" />
      </div>
    </div>
  </authenticated-vue>
</template>

<script>
import { onMounted, onUnmounted, reactive, ref, toRefs } from "vue";
import { Inertia } from "@inertiajs/inertia";
import AuthenticatedVue from "@/Layouts/Authenticated.vue";
import CreateMainProject from "@/Components/Project/CreateMainProject.vue";
import CreateOwner from "@/Components/Project/CreateOwner.vue";
import CreateArea from "@/Components/Project/CreateArea.vue";
import { Toast } from "./index.vue";
import Swal from "sweetalert2";
import CreateSide from "@/Components/Project/CreateSide.vue";

export default {
  components: {
    CreateMainProject,
    CreateOwner,
    CreateArea,
    AuthenticatedVue,
    CreateSide,
  },
  props: {
    budget_years: Array,
    stargics: Array,
    main_projects: Array,
    owners: Array,
    areas: Array,
    project: Object,
    errors: Object,
    mains: Array,
    sides: Array,
    year: Object,
    stargic: Object,
    main: Object,
  },
  setup(props) {
    const {
      budget_years,
      stargics,
      main_projects,
      owners,
      areas,
      project,
      errors,
      mains,
      sides,
      year,
      main,
      stargic,
    } = toRefs(props);
    const openCreateSide = ref(false);
    const openCreateMainProject = ref(false);
    const openCreateOwner = ref(false);
    const openCreateArea = ref(false);
    const formProject = reactive({
      budget_year_id: route().params.yearsId
        ? parseInt(route().params.yearsId)
        : project?.value?.budget_year_id,
      stargic_id: route().params.stargicId
        ? parseInt(route().params.stargicId)
        : project?.value?.stargic_id,
      main_project_id: route().params.mainId
        ? parseInt(route().params.mainId)
        : project?.value?.parent_id,
      side_id:
        route().params.mainId && project?.value?.level == "3"
          ? project?.value?.parent_id
          : null,
      name: project?.value?.name,
      owners: [],
      areas: [],
      project_start: project?.value?.project_start,
      project_end: project?.value?.project_end,
      objectives: project?.value?.objectives || [
        {
          detail: null,
        },
      ],
      budgets: project?.value?.budgets || [
        {
          detail: null,
          number: null,
        },
      ],
      projectFiles: [],
      link: project?.value?.link || null,
    });

    onMounted(() => {
      console.log(project.value);
      const files = project?.value?.project_files;
      const owners = project?.value?.owners;
      const areas = project?.value?.areas;
      if (files && files.length > 0) {
        files.forEach((file) => {
          formProject.projectFiles.push({
            name: file.filename,
            url: `/storage/uploads/${file.filename}`,
          });
        });
      }
      if (owners && owners.length > 0) {
        owners.forEach((owner) => {
          formProject.owners.push(owner.id);
        });
      }
      if (areas && areas.length > 0) {
        areas.forEach((area) => {
          formProject.areas.push(area.id);
        });
      }
      console.log(formProject.projectFiles);
    });

    const AddObjectiveCount = () => {
      formProject.objectives.push({
        detail: null,
      });
    };
    const RemoveObjectiveCount = () => formProject.objectives.pop();

    const AddBudgetCount = () => {
      formProject.budgets.push({
        detail: null,
        number: null,
      });
    };
    const RemoveBudgetCount = () => formProject.budgets.pop();

    const submit = () => {
      if (project.value) {
        Inertia.put(
          route("admin.projects.update", { project: project.value.id }),
          formProject,
          {
            onSuccess: () => {
              Inertia.get(route("admin.projects.index"));
              Toast.fire({
                icon: "success",
                title: "อัพเดทข้อมูลโครงการสำเร็จ ",
              });
            },
          }
        );
      } else {
        Inertia.post(route("admin.projects.store"), formProject, {
          onSuccess: () => {
            Inertia.get(route("admin.projects.index"));
            Toast.fire({
              icon: "success",
              title: "เพิ่มข้อมูลโครงการสำเร็จ ",
            });
          },
        });
      }
    };

    const handleUploadSuccess = (res) => {
      const { status, file_name, msg } = res;
      if (status == 1) {
        formProject.projectFiles.push({
          name: file_name,
        });
      } else {
        Swal.fire({
          icon: "error",
          title: "Oops...",
          text: `${msg}`,
        });
      }
    };
    const beforeUpload = (file) => {
      const isPDF =
        file.type === "application/pdf" || file.type === "application/msword";
      const isLt3M = file.size / 1024 / 1024 < 3;
      if (!isPDF) {
        Swal.fire({
          icon: "error",
          title: "Oops...",
          text: `กรุณาเลือกไฟล์ให้ถูกต้อง`,
        });
      }
      if (!isLt3M) {
        Swal.fire({
          icon: "error",
          title: "Oops...",
          text: `ไฟล์มีขนาดใหญ่เกินไป`,
        });
      }
      return isPDF && isLt3M;
    };
    const handleRemoveSuccess = (file) => {
      formProject.projectFiles = formProject.projectFiles.filter(
        (f) => f.name != file.name
      );
      console.log(formProject.projectFiles);
    };

    const getStargis = () => {
      if (project.value) {
        Inertia.get(
          route("admin.projects.edit", {
            project: project.value.id,
            yearsId: formProject.budget_year_id,
          })
        );
      } else {
        Inertia.get(
          route("admin.projects.create", {
            yearsId: formProject.budget_year_id,
          })
        );
      }
    };

    const getMains = () => {
      if (project.value) {
        Inertia.get(
          route("admin.projects.edit", {
            project: project.value.id,
            yearsId: formProject.budget_year_id,
            stargicId: formProject.stargic_id,
          })
        );
      } else {
        Inertia.get(
          route("admin.projects.create", {
            yearsId: formProject.budget_year_id,
            stargicId: formProject.stargic_id,
          })
        );
      }
    };

    const getSides = () => {
      if (project.value) {
        Inertia.get(
          route("admin.projects.edit", {
            project: project.value.id,
            yearsId: formProject.budget_year_id,
            stargicId: formProject.stargic_id,
            mainId: formProject.main_project_id,
          })
        );
      } else {
        Inertia.get(
          route("admin.projects.create", {
            yearsId: formProject.budget_year_id,
            stargicId: formProject.stargic_id,
            mainId: formProject.main_project_id,
          })
        );
      }
    };

    onUnmounted(() => {
      console.log("unmount");
    });
    return {
      getSides,
      getMains,
      year,
      stargic,
      project,
      getStargis,
      handleRemoveSuccess,
      handleUploadSuccess,
      beforeUpload,
      formProject,
      budget_years,
      stargics,
      main_projects,
      owners,
      areas,
      openCreateSide,
      openCreateMainProject,
      openCreateOwner,
      openCreateArea,
      AddObjectiveCount,
      RemoveObjectiveCount,
      AddBudgetCount,
      RemoveBudgetCount,
      submit,
      errors,
      mains,
      sides,
      main,
    };
  },
};
</script>

<style>
.el-date-editor--daterange.el-input,
.el-date-editor--daterange.el-input__inner,
.el-date-editor--timerange.el-input,
.el-date-editor--timerange.el-input__inner {
  width: 100%;
}
.el-date-editor.el-input,
.el-date-editor.el-input__inner {
  width: 100%;
}
</style>
